##############################################################################
## BODLoader v 0.5a - by Masklin - Feb-2002
##############################################################################

import Bladex
import netgame
import Reference


import Language

import BUIx
import NetMisc

import Menu
import MenuText
import LoadBar

import MenuWidget
import netwidgets
import ScorerWidgets
import KeybWidget

import os
import sys
import string
import shutil
import re
import pprint
import whrandom


Reference.debugprint ("BODLoader: Start")

####################################################################################
# BODLoader Info
####################################################################################

BLVersion       = "0.5a"
BLAuthor        = "Masklin"
BLAuthorInfo    = "masklin@supercable.es"

####################################################################################
# BODLoader Modules
####################################################################################

import stat

def copyfile(src, dst):
    """Copy data from src to dst"""
    fsrc = None
    fdst = None
    try:
        fsrc = open(src, 'rb')
        fdst = open(dst, 'wb')
        while 1:
            buf = fsrc.read(16*1024)
            if not buf:
                break
            fdst.write(buf)
    finally:
        if fdst:
            fdst.close()
        if fsrc:
            fsrc.close()

def copystat(src, dst):
    """Copy all stat info (mode bits, atime and mtime) from src to dst"""
    st = os.stat(src)
    mode = stat.S_IMODE(st[stat.ST_MODE])
    os.utime(dst, (st[stat.ST_ATIME], st[stat.ST_MTIME]))
    os.chmod(dst, mode)

def copy2(src, dst):
    """Copy data and all stat info ("cp -p src dst").

    The destination may be a directory.

    """
    if os.path.isdir(dst):
        dst = os.path.join(dst, os.path.basename(src))
    copyfile(src, dst)
    copystat(src, dst)

def getmtime(filename):
    """Return the last modification time of a file, reported by os.stat()."""
    st = os.stat(filename)
    return st[stat.ST_MTIME]

def CheckRequiredFiles ():
		
  	if not os.path.exists ('../../Scripts/ModBrowser.py') or getmtime ('../../Scripts/ModBrowser.py') != getmtime ('../../BODLoader/ModBrowser.py'):
	   Reference.debugprint ("BODLoader: CheckRequiredFiles: Installing ModBrowser")	
   	   copy2 ('../../BODLoader/ModBrowser.py', '../../Scripts')
   	
   	if not os.path.exists ('../../Scripts/zipfile.py') or getmtime ('../../Scripts/zipfile.py') != getmtime ('../../BODLoader/zipfile.py'):
	   Reference.debugprint ("BODLoader: CheckRequiredFiles: Installing zipfile")	
	   copy2 ('../../BODLoader/zipfile.py', '../../Scripts')
   	
   	if not os.path.exists ('../../Lib/PythonLib/DLLs/zlib.pyd') or getmtime ('../../Lib/PythonLib/DLLs/zlib.pyd') != getmtime ('../../BODLoader/zlib.pyd'):
	   Reference.debugprint ("BODLoader: CheckRequiredFiles: Installing zlib")	
   	   copy2 ('../../BODLoader/zlib.pyd', '../../Lib/PythonLib/DLLs')

CheckRequiredFiles ()

import ModBrowser
import zipfile
#import BLControls

##############################################################################
## Globals
##############################################################################

BLNMods         = 0
BLCurrentMod    = ""
ModName         = ""
ModDesc         = ""
ModVersion      = ""
ModAuthor       = ""
ModAuthorInfo   = ""
ModArenaMode    = 0
ArenaAllowed    = 1
BLMods          = []
BLModInfo       = {}
MenuLabel       = {}

MakeDirs        = []
NewFiles        = {}
RepFiles        = {}

ModMenu         = []
ModOptMenuEnabled = 0

BLCurrentMap    = ""
BLMapInfo       = {}
BLMaps          = []
BLNMaps         = 0

MapName         = ""
MapChar         = ""
MapPosition     = 0,-1500,0
LevelName       = ""

BLServers       = {}
RServers        = []
BLRModInfo      = {}
RServerOnline   = 0
RMods           = []
BLCurrentRMod   = ""
InitProgressBar = 1
ModVerStatus    = "None"

WMods = ModBrowser.WebMods()
MenuLabel['BODVersion']   = "BODLoader   version   "+BLVersion

##############################################################################
## Load BODLoader Data File
##############################################################################

try:
	execfile('../../BODLoader/BLData.py')
except:
	BLCurrentMod  = ''
	BLModInfo     = {}
	BLCurrentMap  = ''
	BLMapInfo     = {}

BLMods = BLModInfo.keys()
BLMaps = BLMapInfo.keys()

# Check for Arena Mode global compatibility
try:
  ArenaAllowed    = 1
except:
  ArenaAllowed    = 0

##############################################################################
## Internal functions
##############################################################################

BLFontSmall="../../BODLoader/Letras BODLoader peq.bmp"
BLFontMed="../../BODLoader/Letras BODLoader med.bmp"
BLFontBig="../../BODLoader/Letras BODLoader gra.bmp"

def Dump (msg, variable):
	pp = pprint.PrettyPrinter(indent=4)

	BLDumpFile=open('../../BODLoader/Dump.txt','at')
	BLDumpFile.write('\n%s\n'%(msg))
	BLDumpFile.write('%s\n'%(pp.pformat (variable)))
	BLDumpFile.close()


import Language
import MenuText

def LoadForeingDict ():
	if Language.Current == "Spanish":
           MenuText.ForeingDict['MODS']               = 'MODS'
           MenuText.ForeingDict['INSTALLED MODS']     = 'MODS INSTALADOS'
           MenuText.ForeingDict['SETUP']              = 'CONFIGURACION'
           MenuText.ForeingDict['LOAD CUSTOM MAP']    = 'CARGAR MAPA EXTERNO'
           MenuText.ForeingDict['DOWNLOADS']          = 'DESCARGAS'
           MenuText.ForeingDict['DOWNLOAD']           = 'DESCARGAR'
           MenuText.ForeingDict['Servers']            = 'Servidores'
           MenuText.ForeingDict['INSTALL']            = 'INSTALAR'
           MenuText.ForeingDict['UNINSTALL']          = 'DESINSTALAR'
           MenuText.ForeingDict['Installed']          = 'Instalado'
           MenuText.ForeingDict['ENABLE']             = 'ACTIVAR'
           MenuText.ForeingDict['DISABLE']            = 'DESACTIVAR'
           MenuText.ForeingDict['No available mods']  = 'No se han encontrado Mods'
           MenuText.ForeingDict['No available maps']  = 'No se han encontrado Mapas'
           MenuText.ForeingDict['Online']             = 'En lnea'
           MenuText.ForeingDict['Offline']            = 'Fuera de lnea'
           MenuText.ForeingDict['Maps : ']            = 'Mapas: '
           MenuText.ForeingDict['Map']                = 'Mapa'
           MenuText.ForeingDict['New version']        = 'Nueva versin'
           MenuText.ForeingDict['New']                = 'Nuevo'
           MenuText.ForeingDict['DOWNLOADING... ']    = 'DESCARGANDO... '
           MenuText.ForeingDict['UPGRADE']            = 'ACTUALIZAR'
           MenuText.ForeingDict['Connecting to a new server...']    = 'Conectando con el nuevo servidor... '
   	   MenuText.ForeingDict['New version available']            = 'Nueva versin disponible'
           MenuText.ForeingDict['Status: Installed and Enabled']    = 'Estado: Instalado y Activo'
           MenuText.ForeingDict['Status: Installed and Disabled']   = 'Estado: Intalado y no Activo'
           MenuText.ForeingDict['Nonavailable version information'] = 'Informacin sobre la versin no disponible'
           MenuText.ForeingDict['Upgrade successful']               = 'Actualizacin finalizada'
           MenuText.ForeingDict['Installation successful']          = 'Instalacin finalizada'
           MenuText.ForeingDict['Current Version Installed']        = 'Version actual instalada'
           MenuText.ForeingDict['Upgrade successful. Please restart Blade']   = 'Actualizacin finalizada. Debes reiniciar Blade'
           MenuText.ForeingDict['Warning: this mod replace RAS core files']   = 'Aviso: Este Mod sustituye ficheros de RAS'

def makedirs(name, mode=0777):

    head, tail = os.path.split(name)
    if head and tail and not os.path.exists(head):
        makedirs(head, mode)
    os.mkdir(name, mode)

def copytree(src, dst):
    names = os.listdir(src)
    try:
       os.mkdir(dst)
    except:
       pass
    for name in names:
        srcname = os.path.join(src, name)
        dstname = os.path.join(dst, name)
        try:
            if os.path.isdir(srcname):
                copytree(srcname, dstname)
            else:
                shutil.copy (srcname, dstname)
        except:
	    pass
	  

def LoadAvailableMods ():
	global BLNMods
	global BLCurrentMod
	global BLMods
	global BLModInfo

	global ModName
	global ModDesc
	global ModVersion
	global ModAuthor
	global ModAuthorInfo
	global NewFiles
	global RepFiles
	global ModArenaMode


	BLCurrentMods   = []
	BLNMods         = 0
	
	BLModInfo_updated = 0
	if not os.path.exists ('../../BODLoader/Mods'):
	  try:
	       makedirs('../../BODLoader/Mods')
	  except:
	       pass
	dirlist = os.listdir("../../BODLoader/Mods/")
	dirlist.sort()
	for dirname in dirlist:
		ModDesc         = ''
		ModVersion      = ''
		ModAuthor       = ''
		ModAuthorInfo   = ''
		ModArenaMode    = 0
		MakeDirs        = []
		NewFiles        = {}
		RepFiles        = {}
		ModMenu         = []
		try:
			execfile ("../../BODLoader/Mods/"+dirname+"/BLModInfo.py")
		except:
			continue		
		Reference.debugprint ("BODLoader:LoadAvailableMods: Procesing "+ModName)
		BLCurrentMods.append (ModName)
		BLNMods = BLNMods +1
		BLCurrentMod = ModName
		BLModInfo_updated = 1
		
		if BLModInfo.has_key (ModName):
			BLModInfo[ModName]['NewVersion']=0
			if BLModInfo[ModName]['Version'] != ModVersion:
			   if BLModInfo[ModName]['Installed']:
			   	BLModInfo[ModName]['NewVersion']=1
			   else:
				BLModInfo[ModName]['NewVersion']=0
				if len (RepFiles):
					ModSmart = 1
				else:
					ModSmart = 0
				BLModInfo [ModName]['Desc']       = ModDesc
				BLModInfo [ModName]['Version']    = ModVersion
				BLModInfo [ModName]['Author']     = ModAuthor
				BLModInfo [ModName]['AuthorInfo'] = ModAuthorInfo
				BLModInfo [ModName]['ModSmart']   = ModSmart
				BLModInfo [ModName]['DirName']    = dirname
				BLModInfo [ModName]['ArenaMode']  = ModArenaMode
			# Update pre 0.5 database
			if not BLModInfo[ModName].has_key('ArenaMode'):
			   BLModInfo[ModName]['ArenaMode'] = ModArenaMode
		else:
			if len (RepFiles):
				ModSmart = 1
			else:
				ModSmart = 0
			BLModInfo [ModName]= {'Desc'        : ModDesc,
	                                      'Version'     : ModVersion,
	                                      'Author'      : ModAuthor,
	                                      'AuthorInfo'  : ModAuthorInfo,
			                      'Installed'   : 0,
			                      'Enabled'     : 0,
					      'Menu'        : ModMenu,
			                      'NewVersion'  : 0,
			                      'ModSmart'    : ModSmart,
			                      'ArenaMode'   : ModArenaMode,
			                      'DirName'     : dirname
			                      }
			
	for mod in BLMods:
	    if mod != MenuText.GetMenuText('No available mods') and mod not in BLCurrentMods:
	       try:
	         del BLModInfo[mod]
	       except:
	         pass
		
	if BLModInfo_updated:
		BLMods = BLCurrentMods
		SaveConfiguration()
	if len (BLMods):
		BLCurrentMod = BLMods[0]


def LoadAvailableMaps ():
	global BLNMaps
	global BLCurrentMap
	global BLMapInfo
	global BLMaps
	
	global MapName
	global MapChar
	global MapPosition
	global MapVersion


	BLMapInfo_updated = 0
	BLCurrentMaps     = []
	BLNMaps           = 0

	if not os.path.exists ('../../BODLoader/Maps'):
	  try:
	       makedirs('../../BODLoader/Maps')
	  except:
	       pass
	dirlist = os.listdir("../../BODLoader/Maps/")
	dirlist.sort()
	for dirname in dirlist:
		MapName        = dirname
		MapChar        = 'Knight'
		MapPosition    = 0,-1500,0
		MapVersion     = ''
		try:
			execfile ("../../BODLoader/Maps/"+dirname+"/BLMapInfo.py")
		except:
			pass
		Reference.debugprint ("BODLoader:LoadAvailableMaps: Procesing "+MapName)
		BLCurrentMaps.append (MapName)
		BLMapInfo_updated = 1
		BLNMaps = BLNMaps +1
		BLCurrentMap = MapName
		
		if BLMapInfo.has_key (MapName):
			BLMapInfo [MapName]['Character']    = MapChar+"_N"
			BLMapInfo [MapName]['Position']     = MapPosition
			if MapVersion != '':
			   BLMapInfo [MapName]['Version']   = MapVersion
		else:
			BLMapInfo [MapName]= {'Character'   : MapChar+"_N",
	                                      'Position'    : MapPosition,
	                                      'Version'     : MapVersion,
			                      'Installed'   : 0,
			                      'DirName'     : dirname
			                      }
			
		
	for map in BLMaps:
	    if map != MenuText.GetMenuText('No available maps') and map not in BLCurrentMaps:
	       try:
	         del BLMapInfo[map]
	       except:
	         pass
		
	if BLMapInfo_updated:
		BLMaps = BLCurrentMaps
		SaveConfiguration()
	if len (BLMaps):
		BLCurrentMap = BLMaps[0]

def SaveConfiguration(xx=0):
	
	global BLCurrentMod
	global BLModInfo
	global BLCurrentMap	
	global BLMapInfo
		

	BLModMenu={}
	
	pp = pprint.PrettyPrinter(indent=4)

	BLDataFile=open('../../BODLoader/BLData.py','w')
	
	BLDataFile.write('####################################################################################\n')
	BLDataFile.write('## BOD Loader Data File\n')
	BLDataFile.write('####################################################################################\n\n')

	#BLData=copy.deepcopy(BLModInfo)
	for mod in BLModInfo.keys():
		BLModMenu[mod]= BLModInfo[mod]['Menu']
		BLModInfo[mod]['Menu']={}

	BLDataFile.write('BLModInfo     = %s\n'%(pp.pformat (BLModInfo)))
	BLDataFile.write('BLMapInfo     = %s\n'%(pp.pformat (BLMapInfo)))
	BLDataFile.close()

	for mod in BLModInfo.keys():
		BLModInfo[mod]['Menu']=BLModMenu[mod]

# Mods

def UpdateModInfo (modname):
	global BLCurrentMod
	global ModDesc
	global ModVersion
	global ModAuthor
	global ModAuthorInfo
	global BLModInfo
	global RepFiles
	global ModArenaMode
	
	global MenuLabel
	
	if not modname:
	   modname = BLCurrentMod

	ModDesc         = ''
	ModVersion      = ''
	ModAuthor       = ''
	ModAuthorInfo   = ''
	RepFiles        = {}
	BLCurrentMod = modname
	GetCurrentMod ()
	if len (RepFiles):
		ModSmart = 1
	else:
		ModSmart = 0
	BLModInfo [modname]['Desc']       = ModDesc
	BLModInfo [modname]['Version']    = ModVersion
	BLModInfo [modname]['Author']     = ModAuthor
	BLModInfo [modname]['AuthorInfo'] = ModAuthorInfo
	BLModInfo [modname]['ModSmart']   = ModSmart
	BLModInfo [modname]['ArenaMode']  = ModArenaMode
	BLModInfo [modname]['DirName']    = dirname
	SaveConfiguration()

def GetCurrentMod():
	global BLCurrentMod
	global ModDesc
	global ModVersion
	global ModAuthor
	global ModAuthorInfo
	global BLMods
	global BLNMods
	global BLModInfo
	global RepFiles
	
	global MenuLabel
	
	ModDesc         = ''
	ModVersion      = ''
	ModAuthor       = ''
	ModAuthorInfo   = ''
	MakeDirs        = []
	NewFiles        = {}
	RepFiles        = {}
	ModMenu         = []

	if BLNMods == 0:
		MenuLabel['Installed']    = ''
		MenuLabel['Enabled']      = ''
		Reference.debugprint ("BODLoader: GetCurrentMod: No available mods")
		BLMods = [MenuText.GetMenuText('No available mods')]
		return 0

	try:
		execfile ("../../BODLoader/Mods/"+BLModInfo[BLCurrentMod]['DirName']+"/BLModInfo.py")
	except:
		import traceback
		traceback.print_exc()
		pass

	if BLCurrentMod == '':
		BLCurrentMod = BLMods[0]

        for n in range (1, 5 - string.count (ModDesc, "\n") ):
   	  ModDesc = ModDesc +"\n"
	MenuLabel['Desc']       = ModDesc
	MenuLabel['Version']    = 'Vers.  '+ModVersion
	MenuLabel['Author']     = ModAuthor
	MenuLabel['AuthorInfo'] = string.replace (ModAuthorInfo,'@','#')


	GetInstallStatus ()
	GetEnableStatus ()

	ShowModOptMenu (BLCurrentMod)
		
	MenuLabel['Msg2'] = ""
	if BLModInfo [BLCurrentMod]['NewVersion']:
		MenuLabel['Msg2'] = MenuText.GetMenuText("New version available")
	elif BLModInfo [BLCurrentMod]['ModSmart']:
		MenuLabel['Msg2'] = MenuText.GetMenuText("Warning: this mod replace RAS core files")
        
        return BLMods.index (BLCurrentMod)

def NextMod (option):
	global BLCurrentMod	
	global BLMods
	global BLModInfo
	global BLNMods

	global ModDesc
	global ModVersion
	global ModAuthor
	global ModAuthorInfo
	
	global MenuLabel

	if BLNMods == 0:
		return

	BLCurrentMod   = option
	ModDesc        = BLModInfo [BLCurrentMod]['Desc']
	ModVersion     = BLModInfo [BLCurrentMod]['Version']
	ModAuthor      = BLModInfo [BLCurrentMod]['Author']
	ModAuthorInfo  = BLModInfo [BLCurrentMod]['AuthorInfo']
	MenuLabel['Desc']       = ModDesc
	MenuLabel['Version']    = 'Vers.  '+ModVersion
	MenuLabel['Author']     = ModAuthor
	MenuLabel['AuthorInfo'] = string.replace (ModAuthorInfo,'@','#')

	GetInstallStatus ()
	GetEnableStatus ()
        
	ShowModOptMenu (BLCurrentMod)

	MenuLabel['Msg2'] = ""
	if BLModInfo [BLCurrentMod]['NewVersion']:
		MenuLabel['Msg2'] = MenuText.GetMenuText("New version available")
	elif BLModInfo [BLCurrentMod]['ModSmart']:
		MenuLabel['Msg2'] = MenuText.GetMenuText("Warning: this mod replace RAS core files")

def ModInstalled (modname=''):
	global BLCurrentMod
	global BLModInfo
	if not modname:
	   modname = BLCurrentMod
        return BLModInfo [modname]['Installed']

def ModEnabled (modname=''):
	global BLCurrentMod
	global BLModInfo
	if not modname:
	   modname = BLCurrentMod
        return BLModInfo [modname]['Enabled']

def GetInstallStatus ():
	global MenuLabel
	global BLCurrentMod
	

	MenuLabel['Msg1'] = ""
        if ModInstalled():
		MenuLabel ['Installed']= MenuText.GetMenuText('UNINSTALL')
		MenuLabel ['Msg1']= MenuText.GetMenuText('Installed')
 	        if ModEnabled():
		   MenuLabel ['Msg1']= MenuText.GetMenuText('Status: Installed and Enabled')
		else:
		   MenuLabel ['Msg1']= MenuText.GetMenuText('Status: Installed and Disabled')

        else:
		MenuLabel ['Installed']= MenuText.GetMenuText('INSTALL')

def GetEnableStatus ():
	global MenuLabel
	
        if not ModInstalled():
		MenuLabel ['Enabled']= ''
        elif   ModEnabled():
		MenuLabel ['Enabled']= MenuText.GetMenuText('DISABLE')
        else:
		MenuLabel ['Enabled']= MenuText.GetMenuText('ENABLE')

def ModInstallUninstall (class_menu):
        if ModInstalled():
		ModDisable ()
		ModUninstall ()
	else:
		ModInstall ()
		ModEnable ()
	GetInstallStatus ()
	GetEnableStatus ()
	ReBuildInstalledModsMenu ()

	
def ModEnableDisable (class_menu):
        if not ModInstalled():
		  pass
        elif   ModEnabled():
		  ModDisable ()
	else:
		  ModEnable ()
  	GetInstallStatus ()
	GetEnableStatus ()
	ReBuildInstalledModsMenu ()

def ModInstall ():
 try:
	global BLCurrentMod
	global BLModInfo
	global MakeDirs
	global NewFiles
	global RepFiles
	global ModMenu

	global ModDesc
	global ModVersion
	global ModAuthor
	global ModAuthorInfo
	global ModArenaMode


	ModDesc         = ''
	ModVersion      = ''
	ModAuthor       = ''
	ModAuthorInfo   = ''
	MakeDirs        = []
	NewFiles        = {}
	RepFiles        = {}
	ModMenu         = []
	ModArenaMode    = 0

	Reference.debugprint ("BODLoader: ModInstall: "+BLCurrentMod)
	# Initialize uninstall support
	InitUninstall (BLModInfo[BLCurrentMod]['DirName'])
	# Get Current mod data
	Reference.debugprint ("BODLoader: ModInstall: Get current mod data")
	try:
	  execfile ("../../BODLoader/Mods/"+BLModInfo[BLCurrentMod]['DirName']+"/BLModInfo.py")
	except:
	  Reference.debugprint ("BODLoader: ModInstall: Error executing BLModInfo.py")
 	  import traceback
	  traceback.print_exc()
	  return
	# Copy Init/Shutdown files
	try:
	       makedirs('../../BODLoader/Init')
	except:
	       pass
	       
	if os.path.exists ('../../BODLoader/Mods/'+BLModInfo[BLCurrentMod]['DirName']+'/BLModInit.py'):
	   shutil.copy ('../../BODLoader/Mods/'+BLModInfo[BLCurrentMod]['DirName']+'/BLModInit.py',
	                 '../../BODLoader/Init/BLInit_'+BLModInfo[BLCurrentMod]['DirName']+'.py')
	   AddUninstall ("os.remove ('../../BODLoader/Init/BLInit_"+BLModInfo[BLCurrentMod]['DirName']+".py')")
	   
	if os.path.exists ('../../BODLoader/Mods/'+BLModInfo[BLCurrentMod]['DirName']+'/BLModShut.py'):
	   shutil.copy ('../../BODLoader/Mods/'+BLModInfo[BLCurrentMod]['DirName']+'/BLModShut.py',
	                 '../../BODLoader/Init/BLShut_'+BLModInfo[BLCurrentMod]['DirName']+'.py')
	   AddUninstall ("os.remove ('../../BODLoader/Init/BLShut_"+BLModInfo[BLCurrentMod]['DirName']+".py')")

	# Make directories
	for dname in MakeDirs:
	    try:
	       Reference.debugprint ("BODLoader: ModInstall: make dir "+dname)
	       makedirs(dname)
	    except:
	       pass
	
	# Copy module files
	Reference.debugprint ("BODLoader: ModInstall: Copying newfiles")
	for i in range (0, len (NewFiles)):
	    Reference.debugprint ("BODLoader: ModInstall: Copying newfile "+`i`)
	    try:
               shutil.copy ('../../BODLoader/Mods/'+BLModInfo[BLCurrentMod]['DirName']+'/'+NewFiles[i]['File'],  NewFiles[i]['Dest'])
            except:
               shutil.copy (NewFiles[i]['File'],  NewFiles[i]['Dest'])

	    if os.path.isdir(NewFiles[i]['Dest']):
	 	    dst=NewFiles[i]['Dest']+'/'+os.path.basename(NewFiles[i]['File'])
	    else:
		    dst=NewFiles[i]['Dest']
            AddUninstall ("os.remove ('"+dst+"')")
	    if re.search ('\.py', dst):
	    	AddUninstall ("if os.path.exists ('"+dst+"c'):\n  os.remove ('"+dst+"c')")	    	

	# Replace module files
	Reference.debugprint ("BODLoader: ModInstall: Replacing repfiles")
	for i in range (0, len (RepFiles)):
   	    try:
	      makedirs('../../BODLoader/Bck/'+BLModInfo[BLCurrentMod]['DirName'])
	    except:
	      pass
	    if os.path.isdir(RepFiles[i]['Dest']):
	 	    src=RepFiles[i]['Dest']+'/'+os.path.basename(RepFiles[i]['File'])
	    else:
		    src=RepFiles[i]['Dest']
	    	    	
            shutil.copy (src, '../../BODLoader/Bck/'+BLModInfo[BLCurrentMod]['DirName'])
            shutil.copy ('../../BODLoader/Mods/'+BLModInfo[BLCurrentMod]['DirName']+'/'+RepFiles[i]['File'],  RepFiles[i]['Dest'])
            AddUninstall ("shutil.copy ('../../BODLoader/Bck/"+BLModInfo[BLCurrentMod]['DirName']+"/"+os.path.basename(src)+"', '"+src+"')")
            AddUninstall ("os.remove ('../../BODLoader/Bck/"+BLModInfo[BLCurrentMod]['DirName']+"/"+os.path.basename(src)+"')")

	# rmdir for uninstall support
	if MakeDirs:
           MakeDirs.reverse()
	   for dname in MakeDirs:
             Reference.debugprint ("BODLoader: ModInstall: rmdir "+dname+" for uninstall support")
             AddUninstall ("if not os.listdir('"+dname+"'):\n  os.removedirs ('"+dname+"')")

	BLModInfo [BLCurrentMod]['Installed']=1
	BLModInfo [BLCurrentMod]['NewVersion']=0
	
	if len (RepFiles):
		ModSmart = 1
	else:
		ModSmart = 0
	BLModInfo [BLCurrentMod]['Desc']       = ModDesc
	BLModInfo [BLCurrentMod]['Version']    = ModVersion
	BLModInfo [BLCurrentMod]['Author']     = ModAuthor
	BLModInfo [BLCurrentMod]['AuthorInfo'] = ModAuthorInfo
	BLModInfo [BLCurrentMod]['ModSmart']   = ModSmart
	BLModInfo [BLCurrentMod]['ArenaMode']  = ModArenaMode

	SaveConfiguration()
        Reference.debugprint ("BODLoader: ModInstall: end")
 except:
	  Reference.debugprint ("BODLoader: ModInstall: Error")
 	  import traceback
	  traceback.print_exc()
	  return

def ModUninstall (modname=''):
	global BLCurrentMod
	global BLModInfo
	if not modname:
	   modname = BLCurrentMod
	Reference.debugprint ("BODLoader: ModUninstall: "+modname)

  	try:
	  execfile ('../../BODLoader/Uns/BLUns_'+BLModInfo[BLCurrentMod]['DirName']+'.py')
	except:
          Reference.debugprint ("BODLoader: ModUninstall: Unistall failed ")
	  import traceback
	  traceback.print_exc()
	  pass
	  
  	try:
	  os.remove ('../../BODLoader/Uns/BLUns_'+BLModInfo[modname]['DirName']+'.py')
	except:
	  pass

	BLModInfo [modname]['Installed']=0
	BLModInfo [modname]['Enabled']=0
	if BLModInfo[modname]['NewVersion']:
	    BLModInfo[modname]['NewVersion']=0
	    UpdateModInfo (modname)
	SaveConfiguration()

	
def InitUninstall (dirname):

	try:
	       makedirs('../../BODLoader/Uns')
	except:
	       pass
	BLUnsFile=open('../../BODLoader/Uns/BLUns_'+dirname+'.py','wt')
	BLUnsFile.write('####################################################################################\n')
	BLUnsFile.write('## BOD Loader Uninstall File for %s\n'%(dirname))
	BLUnsFile.write('####################################################################################\n\n')

	BLUnsFile.write('import shutil\n')
	BLUnsFile.write('import os\n\n')

	BLUnsFile.close()

def AddUninstall (command):
	global BLModInfo
	global BLCurrentMod
	
	BLUnsFile=open('../../BODLoader/Uns/BLUns_'+BLModInfo[BLCurrentMod]['DirName']+'.py','at')
	BLUnsFile.write('%s\n'%(command))
	BLUnsFile.close()
	
def ModEnable (modname=''):
	global BLCurrentMod
	global BLModInfo
	
	if not modname:
	   modname = BLCurrentMod
	Reference.debugprint ("BODLoader: ModEnable: "+modname)
	BLModInfo [modname]['Enabled']=1
	InitMod (modname)
        ShowModOptMenu (modname)
	SaveConfiguration()
	

def ModDisable (modname=''):
	global BLCurrentMod
	global BLModInfo
	global ModMenu
	global ExtensionsMenu

	if not modname:
	   modname = BLCurrentMod

	Reference.debugprint ("BODLoader: ModDisable: "+modname)
	
	ShutMod (modname)
        HideModOptMenu (modname)	
	BLModInfo [BLCurrentMod]['Enabled']=0
	SaveConfiguration()

def InitMod (modname):
	global BLMods
	global BLCurrentMod
	global ModMenu
	global BLModInfo
	global ArenaAllowed

	
	if not modname:
	   modname = BLCurrentMod

	Reference.debugprint ("BODLoader: InitMod: "+modname)
	if netgame.GetNetState() != 0 and not BLModInfo[modname]['ArenaMode']:
	   return
	Reference.debugprint ("BODLoader: InitMod: Initializating "+modname)

	ModMenu  = []
        if not os.path.exists ("../../BODLoader/Init/BLInit_"+BLModInfo[modname]['DirName']+".py"):
           return

        try:
	  try:
            execfile ("../../BODLoader/Init/BLInit_"+BLModInfo[modname]['DirName']+".py")
          except:
	    Reference.debugprint ("BODLoader: InitMod: Error executing Init code for "+modname)
	    import traceback
	    traceback.print_exc()
            pass

	  if len (ModMenu):
	  	BLModInfo[modname]['Menu'] = ModMenu
		SaveConfiguration()
	  	  
        except:
          Reference.debugprint ("BODLoader: InitMod: Error initializating "+modname)
	  pass

def ShutMod (modname):
	global BLCurrentMod
	global BLModInfo
	
	if not modname:
	   modname = BLCurrentMod

	Reference.debugprint ("BODLoader: ShutMod: "+modname)
        if not os.path.exists ("../../BODLoader/Init/BLShut_"+BLModInfo[modname]['DirName']+".py"):
           return

	try:
            execfile ("../../BODLoader/Init/BLShut_"+BLModInfo[modname]['DirName']+".py")
        except:
	    Reference.debugprint ("BODLoader: ShutMod: Error executing Shutdown code for "+modname)
	    import traceback
	    traceback.print_exc()
            pass

def InitializeModules ():
	global BLMods

	for modname in BLMods: 
	    if modname != MenuText.GetMenuText('No available mods'):
	       if ModEnabled (modname):
		  InitMod (modname)


# Maps

def GetCurrentMap():
	global BLCurrentMap
	global BLNMaps
	global BLMapInfo
	global BLMaps
	
	global MenuLabel
	
	if BLNMaps == 0:
		MenuLabel['MapInstalled'] = ''
		Reference.debugprint ("BODLoader: GetCurrentMap: No available maps")
		BLMaps = [MenuText.GetMenuText('No available maps')]
		return 0

	GetMapInstallStatus ()
		       
        return BLMaps.index (BLCurrentMap)

def NextMap (option):
	global BLCurrentMap
	global BLNMaps
	global BLMapInfo
	global BLMaps
	
	global MenuLabel

	if BLNMaps == 0:
		return

	BLCurrentMap   = option

	GetMapInstallStatus ()
        
def MapInstalled (mapname=''):
	global BLCurrentMap
	global BLMapInfo
	if not mapname:
	   mapname = BLCurrentMap
        return BLMapInfo [mapname]['Installed']


def GetMapInstallStatus ():
	global MenuLabel
	global BLCurrentMap
	
        if MapInstalled():
		MenuLabel ['MapInstalled']= MenuText.GetMenuText('UNINSTALL')
        else:
		MenuLabel ['MapInstalled']= MenuText.GetMenuText('INSTALL')

def MapInstallUninstall (class_menu):
        if MapInstalled():
		MapUninstall ()
	else:
		MapInstall ()
	GetMapInstallStatus ()
	

def MapInstall (CurrentMapVersion=None):
	global BLCurrentMap
	global BLMapInfo
   	global LevelName
   	global MapName
	global MapChar
	global MapPosition
	global MapVersion

	Reference.debugprint ("BODLoader: MapInstall: "+BLCurrentMap)

	dname = BLMapInfo[BLCurrentMap]['DirName']

	MapName        = dname
	MapChar        = 'Knight'
	MapPosition    = 0,-1500,0
	MapVersion     = ''
	try:
		execfile ("../../BODLoader/Maps/"+dname+"/BLMapInfo.py")
	except:
		pass

	# Initialize uninstall support
	InitUninstall (dname)

	# Make directories
	try:
	   Reference.debugprint ("BODLoader: MapInstall: make dir ../"+dname+'/Pak')
	   makedirs('../'+dname+'/Pak')
	except:
	   pass

	MapWorld     = ""
	MapWorldDome = "../Casa/casa_d.mmp"
   	LevelName    = BLCurrentMap+'.lvl'
	Mmps         = []
	dirlist = os.listdir("../../BODLoader/Maps/"+dname)
	dirlist.sort()
	for file in dirlist:
	    basename = os.path.basename (file)
	    if basename == 'BLMapInfo.py':
	    	continue
	    ext      = os.path.splitext (basename)[1]
	    if ext == '.bw':
	    	MapWorld = basename
   	    elif   re.search(".+_d\.mmp", basename):
   	             MapWorldDome = basename
   	    elif ext == '.mmp':
   	             Mmps.append (basename)
   	    elif ext == '.lvl':
   	    	     LevelName = basename

            if os.path.isdir('../../BODLoader/Maps/'+dname+'/'+basename):
                   copytree ('../../BODLoader/Maps/'+dname+'/'+basename, '../'+dname+'/'+basename)
   	    else:
	           shutil.copy ('../../BODLoader/Maps/'+dname+'/'+basename, '../'+dname)

	if not os.path.exists ('../'+dname+'/pj.py'):
	    Reference.debugprint ("BODLoader: MapInstall: Generating pj.py")
	    GenPjFile ()

	if not os.path.exists ('../'+dname+'/cfg.py'):
	    Reference.debugprint ("BODLoader: MapInstall: Generating cfg.py")
	    GenCfgFile ()

   	if not os.path.exists ('../'+dname+'/'+LevelName):
   	    Reference.debugprint ("BODLoader: MapInstall: Generating "+LevelName)
   	    GenLvlFile (MapWorld, MapWorldDome, Mmps)

	BLMapInfo [BLCurrentMap]['Installed']=1
	BLMapInfo [BLCurrentMap]['Character']    = MapChar+"_N"
	BLMapInfo [BLCurrentMap]['Position']     = MapPosition
	if CurrentMapVersion:
	   MapVersion = CurrentMapVersion
	BLMapInfo [BLCurrentMap]['Version']      = MapVersion
	SaveConfiguration()
        Reference.debugprint ("BODLoader: MapInstall: end")

def MapUninstall (mapname=''):
	global BLCurrentMap
	global BLMapInfo

	if not mapname:
	   mapname = BLCurrentMap
	Reference.debugprint ("BODLoader: MapUninstall: "+mapname)

  	try:
  	  shutil.rmtree ("../"+BLMapInfo[BLCurrentMap]['DirName'])
	except:
	  pass
	  
	BLMapInfo [mapname]['Installed']=0
	SaveConfiguration()

def LoadMap (menu_clas):
	global BLCurrentMap
	global BLMapInfo

	Reference.debugprint ("BODLoader: LoadMap: Loading map "+BLCurrentMap)
   	Bladex.LoadLevel(BLMapInfo[BLCurrentMap]['DirName'])


##############################################################################
## Menu class
##############################################################################

## Custom menu widgets

if ArenaAllowed or netgame.GetNetState() == 0:
 class B_BLDescriptorLabel(MenuWidget.B_MenuItemTextNoFX):
	def __init__(self,Parent,MenuDescr,StackMenu):
		
		global MenuLabel
		
		MenuWidget.B_MenuItemTextNoFX.__init__(self,Parent,MenuDescr,StackMenu)
		self.SetDrawFunc(self.Draw)
		self.LastLabel = ""
		self.Parent = Parent
		self.VarName = MenuDescr["Name"]
		self.SetText(MenuLabel[self.VarName])
		self.Parent.RecalcLayout()

	def Draw(self,x,y,time):
		global MenuLabel

		if self.GetVisible()==0:
			return

		if self.LastLabel != MenuLabel[self.VarName]:
			self.SetText(MenuLabel[self.VarName])
			self.Parent.RecalcLayout()
			self.LastLabel = MenuLabel[self.VarName]
			self.Parent.RecalcLayout()

		foc=self.GetHasFocus()
		if foc:
			self.SetColor(252,247,167)
		else:
			self.SetColor(207,144,49)
		self.SetAlpha(1.0)
		self.DefDraw(x,y,time)

	def AcceptsFocus(self):
		return 0



 class B_InstallEnable(MenuWidget.B_MenuItemTextNoFX):
	def __init__(self,Parent,MenuDescr,StackMenu):
		global MenuLabel
		MenuWidget.B_MenuItemTextNoFX.__init__(self,Parent,MenuDescr,StackMenu)
		self.SetDrawFunc(self.Draw)
		self.LastLabel = ""
		self.Parent = Parent
		self.VarName = MenuDescr["Name"]
		self.SetText(MenuLabel[self.VarName])
		self.Parent.RecalcLayout()

	def Draw(self,x,y,time):
		global MenuLabel

		if self.GetVisible()==0:
			return

		if self.LastLabel != MenuLabel[self.VarName]:
			self.SetText(MenuLabel[self.VarName])
			self.Parent.RecalcLayout()
			self.LastLabel = MenuLabel[self.VarName]
			self.Parent.RecalcLayout()

		foc=self.GetHasFocus()
		if foc:
			self.SetColor(252,247,167)
		else:
			self.SetColor(207,144,49)
		self.SetAlpha(1.0)
		self.DefDraw(x,y,time)

        def AcceptsFocus(self):
		if self.VarName == 'Enabled' and not ModInstalled():
			return 0
                else:
                	return 1
    
        def ActivateItem(self,activate):
	    if activate:
              try:
                command=self.MenuDescr["Command"]
                command(self)
                return 1
              except:
                return 0
            elif activate==0:
	      self.StackMenu.Pop()


 class B_BLMenuItemOption(MenuWidget.B_MenuItemTextNoFX):
  def __init__(self,Parent,MenuDescr,StackMenu,
               font_server=ScorerWidgets.font_server):

    self.Options=["No option defined.",]
    self.SelOption=0
    self.OptionText='' #MenuDescr["Name"]

    try:
      self.Options=MenuDescr["Options"]
    except KeyError:
      pass

    try:

      GetSelFunc=MenuDescr["SelOptionFunc"]
      OptionSel=GetSelFunc()
      #print "DM OptionSel",self.OptionText,OptionSel,self.Options
      self.SelOption=OptionSel
      print self.SelOption
    except KeyError:
      pass

    MenuWidget.B_MenuItemTextNoFX.__init__(self,Parent,MenuDescr,StackMenu)
    #self.SetDrawFunc(self.Draw)
    self.Parent=Parent

    OptionText=self.OptionText+" < "+str(self.Options[self.SelOption])+" >"
    self.SetText(OptionText)

  def __del__(self):
    pass
    #print "B_MenuItemOption.__del__()",self.Name()

  def ActivateItem(self,activate):
    if (activate==1):
    	
      self.SelOption=self.SelOption+1
      self.SelOption=self.SelOption% len(self.Options)

      OptionText=self.OptionText+" < "+self.Options[self.SelOption]+" >"
      self.SetText(OptionText)

      try: # Puede que Parent no herede de Frame
        self.Parent.RecalcLayout()
      except:
        pass

      try:
        command=self.MenuDescr["Command"]
        command(MenuText.GetInverseMenuText(self.Options[self.SelOption]))
      except KeyError:
        pass

      try: # Puede que Parent no herede de Frame
        self.Parent.RecalcLayout()
      except:
        pass

    elif activate==0:
      self.StackMenu.Pop()

  def FinalRelease(self):
    print "B_MenuItemOption.FinalRelease()"
    self.Parent=None
    #self.SetDrawFunc(None)

  def IncMenuItem(self):
    self.ActivateItem(1)


  def DecMenuItem(self):

      self.SelOption=self.SelOption+len(self.Options)-1
      self.SelOption=self.SelOption% len(self.Options)
      OptionText=self.OptionText+" < "+self.Options[self.SelOption]+" >"
      self.SetText(OptionText)

      try: # Puede que Parent no herede de Frame
        self.Parent.RecalcLayout()
      except:
        pass

      try:
        command=self.MenuDescr["Command"]
        command(MenuText.GetInverseMenuText(self.Options[self.SelOption]))
      except KeyError:
        pass

      try: # Puede que Parent no herede de Frame
        self.Parent.RecalcLayout()
      except:
        pass

 class B_BLMenuItemTextNoFX(BUIx.B_TextWidget, MenuWidget.B_MenuTreeItem):
  def __init__(self,Parent,MenuDescr,StackMenu,
               font_server=ScorerWidgets.font_server):
    #print "B_MenuItemText.__init__()",MenuDescr["Name"]
    font="..\\..\\Data\\Letras menu med.bmp"
    try:
      font=MenuDescr["Font"]
    except KeyError:
      pass

    BUIx.B_TextWidget.__init__(self,Parent,"SubMenu"+MenuDescr["Name"],MenuDescr["Name"],font_server,font)
    MenuWidget.B_MenuTreeItem.__init__(self,MenuDescr,StackMenu)
    self.SetDrawFunc(self.Draw)
    self.SetAlpha(1.0)
    self.thisown=1
    self.MenuText=MenuDescr["Name"]
    if self.IsVisible():
	#self.SetVisible(1)
         self.SetAlpha(1.0)
    else:
         self.SetAlpha(0.0)
	#self.SetVisible(0)

  def __del__(self):
    #print "B_MenuItemText.__del__()",self.Name()
    pass

  def __str__(self):
    print "B_MenuItemTextNoFX widget with text",self.GetTextData()

  def IsEnabled (self):
    global ModOptMenuEnabled
    global RServerOnline
    global MenuLabel

    if   self.MenuText == MenuText.GetMenuText("OPTIONS"):
    	   return ModOptMenuEnabled
    elif self.MenuText == MenuText.GetMenuText("CONTINUE"):
    	   return RServerOnline
    elif re.search ('>', self.MenuText):
    	return 1
    else:
        return 0

  def IsVisible (self):
    global ModOptMenuEnabled
    global RServerOnline
    global MenuLabel

    if   self.MenuText == MenuText.GetMenuText("OPTIONS"):
    	   return ModOptMenuEnabled
    elif self.MenuText == MenuText.GetMenuText("CONTINUE"):
    	   return RServerOnline
    else:
        return 1

  def Draw(self,x,y,time):

    if self.IsVisible():
         self.SetAlpha(1.0)
    else:
         self.SetAlpha(0.0)

    if self.GetVisible()==0:
      return

    #print "MenuItemText",self.Name()
    foc=self.GetHasFocus()
    if foc:
      self.SetColor(252,247,167)
    else:
      self.SetColor(207,144,49)

    self.DefDraw(x,y,time)

  def AcceptsFocus(self):
    if self.IsEnabled():
	return 1
    else:
       	return 0
       
 class B_BLMenuItemTextNoFXStart (BUIx.B_TextWidget, MenuWidget.B_MenuTreeItem):
  def __init__(self,Parent,MenuDescr,StackMenu,
               font_server=ScorerWidgets.font_server):
    #print "B_MenuItemText.__init__()",MenuDescr["Name"]
    font="..\\..\\Data\\Letras menu med.bmp"
    try:
      font=MenuDescr["Font"]
    except KeyError:
      pass

    BUIx.B_TextWidget.__init__(self,Parent,"SubMenu"+MenuDescr["Name"],MenuDescr["Name"],font_server,font)
    MenuWidget.B_MenuTreeItem.__init__(self,MenuDescr,StackMenu)
    self.SetDrawFunc(self.Draw)
    self.SetAlpha(1.0)
    self.thisown=1
    self.MenuText=MenuDescr["Name"]
    if self.IsVisible():
	#self.SetVisible(1)
         self.SetAlpha(1.0)
    else:
         self.SetAlpha(0.0)
	#self.SetVisible(0)

  def __del__(self):
    #print "B_MenuItemText.__del__()",self.Name()
    pass

  def __str__(self):
    print "B_MenuItemTextNoFX widget with text",self.GetTextData()

  def IsEnabled (self):
    global MenuLabel

    if MenuLabel['MapInstalled']==MenuText.GetMenuText("UNINSTALL"):
	   return 1
    else:
	   return 0

  def IsVisible (self):
    global MenuLabel

    if MenuLabel['MapInstalled']==MenuText.GetMenuText("UNINSTALL"):
	   return 1
    else:
	   return 0

  def Draw(self,x,y,time):

    if self.IsVisible():
         self.SetAlpha(1.0)
    else:
         self.SetAlpha(0.0)

    if self.GetVisible()==0:
      return

    #print "MenuItemText",self.Name()
    foc=self.GetHasFocus()
    if foc:
      self.SetColor(252,247,167)
    else:
      self.SetColor(207,144,49)

    self.DefDraw(x,y,time)

  def AcceptsFocus(self):
    if self.IsEnabled():
	return 1
    else:
       	return 0

  def ActivateItem(self,activate):
    if activate:
         try:
            command=self.MenuDescr["Command"]
            command(self)
            return 1
         except:
            return 0
    elif activate==0:
       self.StackMenu.Pop()

 class B_BLMenuItemTextNoFXDownload (BUIx.B_TextWidget, MenuWidget.B_MenuTreeItem):
  def __init__(self,Parent,MenuDescr,StackMenu,
               font_server=ScorerWidgets.font_server):
    #print "B_MenuItemText.__init__()",MenuDescr["Name"]
    font="..\\..\\Data\\Letras menu med.bmp"
    try:
      font=MenuDescr["Font"]
    except KeyError:
      pass

    BUIx.B_TextWidget.__init__(self,Parent,"SubMenu"+MenuDescr["Name"],MenuDescr["Name"],font_server,font)
    MenuWidget.B_MenuTreeItem.__init__(self,MenuDescr,StackMenu)
    self.SetDrawFunc(self.Draw)
    self.SetAlpha(1.0)
    self.thisown=1
    self.MenuText=MenuDescr["Name"]
    if self.IsVisible():
	#self.SetVisible(1)
         self.SetAlpha(1.0)
    else:
         self.SetAlpha(0.0)
	#self.SetVisible(0)

  def __del__(self):
    #print "B_MenuItemText.__del__()",self.Name()
    pass

  def __str__(self):
    print "B_MenuItemTextNoFX widget with text",self.GetTextData()

  def IsEnabled (self):
    global ModVerStatus
    if ModVerStatus == "Same":
       return 0
    else:
       return 1

  def IsVisible (self):
    global ModVerStatus
    if ModVerStatus == "Same":
       return 0
    else:
       return 1

  def Draw(self,x,y,time):

    global BLCurrentRMod
    global ModVerStatus

    if self.IsVisible():
         self.SetAlpha(1.0)
    else:
         self.SetAlpha(0.0)

    if self.GetVisible()==0:
      return

    if BLCurrentRMod == 'BODLoader':
       self.SetText(MenuText.GetMenuText("UPGRADE"))
    else:
       if   ModVerStatus == "New":
            self.SetText(MenuText.GetMenuText("INSTALL"))
       elif ModVerStatus == "Updated":
            self.SetText(MenuText.GetMenuText("UPGRADE"))
       elif ModVerStatus == "IUpdated":
            self.SetText(MenuText.GetMenuText("UPGRADE"))
       else:
            self.SetText("") # Never

    #print "MenuItemText",self.Name()
    foc=self.GetHasFocus()
    if foc:
      self.SetColor(252,247,167)
    else:
      self.SetColor(207,144,49)

    self.DefDraw(x,y,time)

  def AcceptsFocus(self):
    if self.IsEnabled():
	return 1
    else:
       	return 0

  def ActivateItem(self,activate):
    global BLCurrentRMod
    global ModVerStatus
    if activate:
         try:
	    if BLCurrentRMod == 'BODLoader':
       	      command=BLUpgrade
    	    else:
              if   ModVerStatus == "New":
       	           command=RInstall                  # Download + Install
              elif ModVerStatus == "Updated":
       	           command=RInstall                  # Download + Install
              elif ModVerStatus == "IUpdated":
       	           command=RUpgrade                  # Download + Uninstall + Install
              else:
	           command=self.MenuDescr["Command"] # Never
            command(self)
            return 1
         except:
            return 0
    elif activate==0:
       self.StackMenu.Pop()
       
class B_Servers (MenuWidget.B_MenuItemTextNoFX):
	def __init__(self,Parent,MenuDescr,StackMenu):
		global BLServers
		global SrvIdx
		MenuWidget.B_MenuItemTextNoFX.__init__(self,Parent,MenuDescr,StackMenu)
		self.SetDrawFunc(self.Draw)
		self.Parent = Parent
		self.VarName = int (MenuDescr["Name"])
		SrvIdx = self.VarName
		self.SetText(BLServers[self.VarName]['Name']+'    ('+BLServers[self.VarName]['Location']+')')
		self.Parent.RecalcLayout()

	def Draw(self,x,y,time):

		if self.GetVisible()==0:
			return

		foc=self.GetHasFocus()
		if foc:
			self.SetColor(252,247,167)
		else:
			self.SetColor(207,144,49)
		self.SetAlpha(1.0)
		self.DefDraw(x,y,time)

        def AcceptsFocus(self):
                return 1
    
        def ActivateItem(self,activate):
	    if activate:
              try:
                command=self.MenuDescr["Command"]
                command(self)
                return 1
              except:
                return 0
            elif activate==0:
	      self.StackMenu.Pop()

##############################################################################
## Menu management
##############################################################################

def NullCommand (menu_clas):
	Reference.debugprint ("BODLoader: NullCommand: Oops")	


def ShowModOptMenu (modname):
	global BLCurrentMod
	global BLModInfo
	global ModOptMenuEnabled
		
	if not modname:
	   modname = BLCurrentMod
	
	if BLModInfo[modname]['Enabled']:
	   if len (BLModInfo[modname]['Menu']):
	     Menu.GetMenuItem(['MODS','SETUP','OPTIONS'])["ListDescr"]=BLModInfo[modname]['Menu']
	     ModOptMenuEnabled = 1
	else:
	     ModOptMenuEnabled = 0
   
def HideModOptMenu (modname):
	global BLCurrentMod
	global BLModInfo
	global ModOptMenuEnabled
	
	if not modname:
	   modname = BLCurrentMod

	if ModOptMenuEnabled:
	       Menu.GetMenuItem(['MODS','SETUP','OPTIONS'])["ListDescr"]=[]
	       ModOptMenuEnabled = 0


def ReBuildInstalledModsMenu ():
	global BLCurrentMod
	global BLModInfo
	global MenuLabel

	ModOptMenus = [{"Name":'InstalledMods',
                                "VSep":100,
                                "Kind":B_BLDescriptorLabel
                        }]

	for modname in BLMods:
	
    	    if modname != MenuText.GetMenuText('No available mods'):
	      if not BLModInfo[modname]['Installed']:
	    	continue
	      if ModEnabled (modname):
	    	MText = '>  '+ modname + '  <'
	      else:
	    	MText = modname
	      ModMenu=BLModInfo[modname]['Menu']
	      if len(ModMenu):
	    	ModOptMenus.append ({"Name":MText,
	     	                    "Kind":B_BLMenuItemTextNoFX,
                                    "VSep":10,
                                    "ListDescr":ModMenu
                                  })               
	      else:
    	    	ModOptMenus.append ({"Name":MText,
	     	                     "Kind":B_BLMenuItemTextNoFX,
                                     "VSep":10,
                                     "ListDescr":[]
                                   })
    	    else:
	      MText = modname

    	ModOptMenus.append ({"Name"       : MenuText.GetMenuText("BACK"),
                             "VSep"       : 20,
                             "Command"    : Menu.BackMenu,
                            })
    	ModOptMenus.append ({"Name"       : "Back",
                             "Kind"       : MenuWidget.B_BackBlank
                            })
        Menu.GetMenuItem(['MODS','INSTALLED MODS'])["ListDescr"]= ModOptMenus



def InitializeServers():
	global BLServers
	global SrvIdx
	global RServers
	
	BLServers[0] ={'url':'http://www.dahlby.net/games/blade/',
		       'Name':'Blade Mods',
		       'Location':'USA',
		       'WebSite':'http://www.dahlby.net/games/blade/'}
	BLServers[1] ={'url':'http://quetzal.uco.es/blade/',
                       'Name':'BODPlanet',
		       'Location':'Europe',
		       'WebSite':'http://alianza.meristation.com/blade/'}
	SrvIdx = 0
	for srvidx in range (0, len(BLServers)):
		RServers.append (BLServers[srvidx]['Name'])
	WMods.urlroot = BLServers[SrvIdx]['url']

def NewVersion (modname):
	global BLRModInfo
	global BLModInfo
	global BLMapInfo
	global MenuLabel
	
	if not modname:
	   return 0
	
	if BLRModInfo [modname]['Type'] == 'Mod':
	   if BLModInfo.has_key(modname):
	      if BLRModInfo [modname]['Version'] != BLModInfo [modname]['Version']:
	         return 1
	else:
	   if   BLMapInfo.has_key(modname):
	        if BLRModInfo [modname]['Version'] != BLMapInfo [modname]['Version']:
	           return 1
	   elif BLMapInfo.has_key(BLRModInfo[modname]['DirName']):
	        try:
	          if BLRModInfo [modname]['Version'] != BLMapInfo [BLRModInfo[modname]['DirName']]['Version']:
	            return 1
	        except:
	          return 1
        return 0
        
def GetCurrentServer():
	global SrvIdx
	global BLServers
        global RServerOnline
        global MenuLabel
	global BLRModInfo
	global BLModInfo
	global RMods


	MenuLabel['RSLocation'] = BLServers[SrvIdx]['Location']
	MenuLabel['RSWebSite']  = BLServers[SrvIdx]['WebSite']
	MenuLabel['RSStatus']   = MenuText.GetMenuText("Offline")
        Menu.GetMenuItem(['MODS','DOWNLOADS','CONTINUE'])["ListDescr"]=[]
	MenuLabel['RSNMods']    = MenuText.GetMenuText("Mods : ")+'0'
	MenuLabel['RSNMaps']    = MenuText.GetMenuText("Maps : ")+'0'
        RemoteMods = []
        WMods.urlroot = BLServers[SrvIdx]['url']
	Reference.debugprint ("BODLoader: GetCurrentServer: Fetching from "+WMods.urlroot)	
	RServerOnline = WMods.FetchMods()
	if RServerOnline:
	   RemoteMods = WMods.GetModList ()
           for modid in range (0, len (RemoteMods)):
 	       BLRModInfo [RemoteMods[modid]['modname']]= {
 	          'Desc'        : '',
	          'Version'     : RemoteMods[modid]['modversion'],
	          'Author'      : RemoteMods[modid]['modauthor'],
	          'AuthorInfo'  : RemoteMods[modid]['modwebsite'],
	          'url'         : RemoteMods[modid]['modurl'],
                  'Size'        : RemoteMods[modid]['modsize'],
                  'Type'        : string.capitalize(RemoteMods[modid]['modtype']),
                  'DirName'     : RemoteMods[modid]['moddirname'],
                  'NewVersion'  : 0
		 }
   	       BLRModInfo [RemoteMods[modid]['modname']]['NewVersion']=NewVersion (RemoteMods[modid]['modname'])
   	       if len (RemoteMods[modid]['moddesc']):
		  try:
   	       	     BLRModInfo [RemoteMods[modid]['modname']]['Desc'] = RemoteMods[modid]['moddesc'][Language.Current]
   	       	  except:
		     try:
   	       	        BLRModInfo [RemoteMods[modid]['modname']]['Desc'] = RemoteMods[modid]['moddesc']['English']
   	       	     except:
   	       	        pass
	       for n in range (1, 5 - string.count (BLRModInfo [RemoteMods[modid]['modname']]['Desc'], "\n") ):
	   	  BLRModInfo [RemoteMods[modid]['modname']]['Desc'] = BLRModInfo [RemoteMods[modid]['modname']]['Desc']+"\n"
   	       	  
	
	   RMods=BLRModInfo.keys()
	   MenuLabel['RSStatus']   = MenuText.GetMenuText("Online")
           Menu.GetMenuItem(['MODS','DOWNLOADS','CONTINUE'])["ListDescr"]=[
                         		{"Name":'RType',
                          		 "VSep":30,
                          		 "Font":Menu.MenuFontMed,
                          		 "Kind":B_BLDescriptorLabel
                         		},
           	                        {"Name":"",
                          		 "Font":Menu.MenuFontBig,
                          		 "Kind":B_BLMenuItemOption,
                          		 "VSep":30,
                          		 "Options":RMods,
                          		 "SelOptionFunc":GetCurrentRMod,
                          		 "Command":NextRMod
                         		},
                         		{"Name":'RVersion',
                          		 "VSep":2,
                          		 "Font":Menu.MenuFontSmall,
                          		 "Kind":B_BLDescriptorLabel
                         		},
                         		{"Name":'RDesc',
                          		 "VSep":10,
                          		 "Kind":B_BLDescriptorLabel
                         		},
                         		{"Name":'RAuthor',
                          		 "VSep":10,
                          		 "Kind":B_BLDescriptorLabel
                         		},
                         		{"Name":'RAuthorInfo',
                          		 "VSep":10,
                          		 "Font":BLFontMed,
                          		 "Kind":B_BLDescriptorLabel
                         		},
                         		{"Name":'RSize',
                          		 "VSep":30,
                          		 "Font":BLFontMed,
                          		 "Kind":B_BLDescriptorLabel
                         		},
                         		{"Name":MenuText.GetMenuText("DOWNLOAD"),
	     	          		 "Kind":B_BLMenuItemTextNoFXDownload,
                          		 "VSep":40,
		                         "Command":NullCommand
                         		},                
                         		{"Name":'RNewVersion',
                          		 "VSep":10,
                          		 "Kind":B_BLDescriptorLabel
                         		},                
                         		{"Name"       : MenuText.GetMenuText("BACK"),
		                         "VSep"       : 20,
                          		 "Command"    : Menu.BackMenu,
                         		},
                         		{"Name"       : "Back",
                          		 "Kind"       : MenuWidget.B_BackBlank
                         		}
				      ]

	   MenuLabel['RSNMods']    = MenuText.GetMenuText("Mods : ")+`WMods.GetModCount()`
	   MenuLabel['RSNMaps']    = MenuText.GetMenuText("Maps : ")+`WMods.GetMapCount()`

	MenuLabel['RDesc']       = ''
	MenuLabel['RVersion']    = ''
	MenuLabel['RAuthor']     = ''
	MenuLabel['RAuthorInfo'] = ''
	MenuLabel['RSize']       = ''
	MenuLabel['RType']       = ''
	MenuLabel['RNewVersion'] = ''

	return SrvIdx

def NextServer(option):	
	global SrvIdx
	global BLServers
	global MenuLabel
	
	for srvidx in range (0, len(BLServers)):
		if BLServers[srvidx]['Name'] == option:
		   SrvIdx = srvidx
		   break
	GetCurrentServer()
		

def GetCurrentRMod():

	global MenuLabel
	global BLRModInfo
	global BLModInfo
	global BLMapInfo
	global RMods
	global BLCurrentRMod
	global RServerOnline
	global ModVerStatus
	global BLVersion

	if not RServerOnline:
	   return 0

	if BLCurrentRMod == "":
		BLCurrentRMod = RMods[0]

	MenuLabel['RDesc']       = BLRModInfo [BLCurrentRMod]['Desc']
	MenuLabel['RVersion']    = 'Vers.  '+BLRModInfo [BLCurrentRMod]['Version']
	MenuLabel['RAuthor']     = BLRModInfo [BLCurrentRMod]['Author']
	MenuLabel['RAuthorInfo'] = BLRModInfo [BLCurrentRMod]['AuthorInfo']
	MenuLabel['RSize']       = BLRModInfo [BLCurrentRMod]['Size']
	MenuLabel['RType']       = MenuText.GetMenuText(BLRModInfo [BLCurrentRMod]['Type'])

	MenuLabel['RNewVersion'] = ""
	if BLRModInfo [BLCurrentRMod]['Type'] == 'Mod':
	    if not BLModInfo.has_key(BLCurrentRMod):
#               MenuLabel ['RNewVersion'] = MenuText.GetMenuText("New")
	       if BLCurrentRMod == 'BODLoader':
	          if  BLRModInfo [BLCurrentRMod]['Version'] != BLVersion:	
                      ModVerStatus = "New"
                  else:
                      ModVerStatus = "Same"
	       else:
                 ModVerStatus = "New"
	    elif NewVersion (BLCurrentRMod):
	       if  BLRModInfo [BLCurrentRMod]['Version'] == '':	
		    MenuLabel ['RNewVersion'] = MenuText.GetMenuText("Nonavailable version information")
#	       else:		
#		    MenuLabel ['RNewVersion'] = MenuText.GetMenuText("New version")
	       if ModInstalled (BLCurrentRMod):
	            ModVerStatus = "IUpdated"
	       else:
	            ModVerStatus = "Updated"
	    else:
	       MenuLabel ['RNewVersion'] = MenuText.GetMenuText("Current Version Installed")
               ModVerStatus = "Same"
	else:	
	    if   BLMapInfo.has_key(BLCurrentRMod):
	         mapname = BLCurrentRMod
    	    elif BLMapInfo.has_key(BLRModInfo[BLCurrentRMod]['DirName']):
	         mapname = BLRModInfo[BLCurrentRMod]['DirName']
	    else:
	         mapname = None
	    if not mapname:
#               MenuLabel ['RNewVersion'] = MenuText.GetMenuText("New")
               ModVerStatus = "New"
	    elif NewVersion (BLCurrentRMod):
	       if  BLRModInfo [BLCurrentRMod]['Version'] == '':	
		   MenuLabel ['RNewVersion'] = MenuText.GetMenuText("Nonavailable version information")
#	       else:		
#		    MenuLabel ['RNewVersion'] = MenuText.GetMenuText("New version")
	       if MapInstalled (mapname):
	            ModVerStatus = "IUpdated"
	       else:
	            ModVerStatus = "Updated"
	    else:
	       MenuLabel ['RNewVersion'] = MenuText.GetMenuText("Current Version Installed")
               ModVerStatus = "Same"
	      
	
	return RMods.index (BLCurrentRMod)

def NextRMod(option):
	global RMods
	global BLCurrentRMod
	
	BLCurrentRMod = option
	GetCurrentRMod ()


def UpdProgressBar ( blocks, blocksize, filesize):
	global MenuLabel
	global InitProgressBar
	global ProgressBar
	

	if InitProgressBar:
	   ProgressBar=LoadBar.AutoProgressBar (int(filesize/(blocksize))+1, "      "+MenuText.GetMenuText("DOWNLOADING... "), "../../BODLoader/Download.jpg")	
	   InitProgressBar = 0

	percent=int((float(blocks)/float((filesize / blocksize) + 1)) * 100)
	ProgressBar.Increment(`percent`+' %')


def DownloadRMod (menu_clas, zipdir=None):
	global BLCurrentRMod
	global BLRModInfo
	global MenuLabel
	global ProgressBar
	global InitProgressBar

	try:
	       makedirs('../../BODLoader/Downloads')
	except:
	       pass

	Reference.debugprint ("BODLoader: DownloadRMod: Downloading mod "+BLCurrentRMod)	
	zipname= '../../BODLoader/Downloads/'+BLRModInfo[BLCurrentRMod]['DirName']+'.zip'
	WMods.DownloadMod (BLRModInfo[BLCurrentRMod]['url'], zipname, UpdProgressBar)

	Reference.debugprint ("BODLoader: DownloadRMod: unziping "+BLCurrentRMod)
	if not zipdir:
	   zipdir = '../../BODLoader/'+ BLRModInfo[BLCurrentRMod]['Type']+'s/'+ BLRModInfo[BLCurrentRMod]['DirName']
  	   try:
  	     shutil.rmtree (zipdir)
	   except:
	     pass
	zipfile.unzip (zipname, zipdir)
	
	ProgressBar.Clear()
	del ProgressBar
        InitProgressBar = 1
        

def BLUpgrade (menu_clas):
	global BLCurrentRMod
	global MenuLabel
	global BLVersion
	global ModVerStatus
	
	Reference.debugprint ("BODLoader: BLUpgrade: Downloading "+BLCurrentRMod)	
	DownloadRMod (None, '../../')
	
	try:
  	 if os.path.exists ('../../Scripts/ModBrowser.py'):
  	    os.remove ('../../Scripts/ModBrowser.py')
  	 if os.path.exists ('../../Scripts/ModBrowser.pyc'):
  	    os.remove ('../../Scripts/ModBrowser.pyc')
   	 copy2 ('../../BODLoader/ModBrowser.py', '../../Scripts')

   	 if os.path.exists ('../../Scripts/zipfile.py'):
  	    os.remove ('../../Scripts/zipfile.py')
  	 if os.path.exists ('../../Scripts/zipfile.pyc'):
  	    os.remove ('../../Scripts/zipfile.pyc')
   	 copy2 ('../../BODLoader/zipfile.py', '../../Scripts')
   	
# Don't work: the dll is opened by Blade, wait until next startup	 
#   	 if os.path.exists ('../../Lib/PythonLib/DLLs/zlib.pyd'):
#  	    os.remove ('../../Lib/PythonLib/DLLs/zlib.pyd')
#   	 copy2 ('../../BODLoader/zlib.pyd', '../../Lib/PythonLib/DLLs')
   	
  	 if os.path.exists ('../../Scripts/BODLoader.py'):
  	    os.remove ('../../Scripts/BODLoader.py')
  	 if os.path.exists ('../../Scripts/BODLoader.pyc'):
  	    os.remove ('../../Scripts/BODLoader.pyc')
   	 copy2 ('../../BODLoader/BODLoader.py', '../../Scripts')

 	except:
	 import traceback
	 traceback.print_exc()
	 pass

   	MenuLabel ['RNewVersion'] = MenuText.GetMenuText("Upgrade successful. Please restart Blade")
   	BLVersion = BLRModInfo [BLCurrentRMod]['Version']
	ModVerStatus = "Same"   	

		
def RInstall (menu_clas):
	global BLCurrentRMod
	global MenuLabel
	global BLCurrentMod
	global BLCurrentMap
	global ModVerStatus
	global BLMaps
	global BLMods
	global BLRModInfo
	global BLMapInfo
	
	Reference.debugprint ("BODLoader: RInstall: Downloading "+BLCurrentRMod)	
	DownloadRMod (None)
        if BLRModInfo[BLCurrentRMod]['Type'] == 'Mod':

           LoadAvailableMods ()
	   BLCurrentMod = BLCurrentRMod
	   ModInstall ()
	   ModEnable ()
	   Menu.GetMenuItem(['MODS','SETUP','Mods'])["Options"]=BLMods
	   ReBuildInstalledModsMenu ()
	else:
	   LoadAvailableMaps ()
	   # Default MapName is DirName
	   if BLMapInfo.has_key(BLCurrentRMod):
	      BLCurrentMap = BLCurrentRMod
	   else:
	      BLCurrentMap = BLRModInfo[BLCurrentRMod]['DirName']
	   MapInstall (BLRModInfo[BLCurrentRMod]['Version'])
	   GetMapInstallStatus ()
	   Menu.GetMenuItem(['MODS','LOAD CUSTOM MAP','Maps'])["Options"]=BLMaps

	ModVerStatus = "Same"

   	MenuLabel ['RNewVersion'] = MenuText.GetMenuText("Installation successful")

def RUpgrade (menu_clas):
	global BLCurrentRMod
	global BLCurrentMod
	global BLCurrentMap
	global MenuLabel
	global ModVerStatus
	global BLMapInfo
		
	Reference.debugprint ("BODLoader: RUpgrade: Downloading "+BLCurrentRMod)		

	BLCurrentMod = BLCurrentRMod
        if BLRModInfo[BLCurrentRMod]['Type'] == 'Mod':
	   BLCurrentMod = BLCurrentRMod        	
	   ModDisable ()
	   ModUninstall ()
	else:
	   if BLMapInfo.has_key(BLCurrentRMod):
	      BLCurrentMap = BLCurrentRMod
	   else:
	      BLCurrentMap = BLRModInfo[BLCurrentRMod]['DirName']
	   MapUninstall ()
	   
	RInstall (None)

   	MenuLabel ['RNewVersion'] = MenuText.GetMenuText("Upgrade successful")
		   	
def BuildExtensionsMenu():
	
	global MenuLabel
	global RServers

	MapMenu =       [
                         {"Name":"Maps",
                          "Font":Menu.MenuFontMed,
                          "Kind":B_BLMenuItemOption,
                          "VSep":100,
                          "Options":BLMaps,
                          "SelOptionFunc":GetCurrentMap,
                          "Command":NextMap
                         },
                         {"Name":MenuText.GetMenuText("START"),
	     	          "Kind":B_BLMenuItemTextNoFXStart,
                          "VSep":30,
                          "Command":LoadMap
                         },                
                         {"Name":'MapInstalled',
                          "Kind":B_InstallEnable,
                          "VSep":10,
                          "Command":MapInstallUninstall
                         },
                         {"Name"       : MenuText.GetMenuText("BACK"),
                          "VSep"       : 20,
                          "Command"    : Menu.BackMenu,
                         },
                         {"Name"       : "Back",
                          "Kind"       : MenuWidget.B_BackBlank
                         }
                        ]

	MenuLabel ['InstalledMods'] = MenuText.GetMenuText("INSTALLED MODS")
	InstalledModsMenu  = [
                               {"Name":'InstalledMods',
                                "VSep":100,
                                "Kind":B_BLDescriptorLabel
                               },
                               {"Name"       : MenuText.GetMenuText("BACK"),
                                "VSep"       : 20,
                                "Command"    : Menu.BackMenu,
                               },
                               {"Name"       : "Back",
                               "Kind"       : MenuWidget.B_BackBlank
                               }
                              ]
	ModConfigMenu = [
                         {"Name":"Mods",
                          "Font":Menu.MenuFontMed,
                          "Kind":B_BLMenuItemOption,
                          "VSep":80,
                          "Options":BLMods,
                          "SelOptionFunc":GetCurrentMod,
                          "Command":NextMod
                         },
                         {"Name":'Version',
                          "VSep":2,
                          "Font":Menu.MenuFontSmall,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'Desc',
                          "VSep":10,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'Author',
                          "VSep":10,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'AuthorInfo',
                          "VSep":1,
                          "Font":BLFontMed,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'Installed',
                          "Kind":B_InstallEnable,
                          "VSep":30,
                          "Command":ModInstallUninstall
                         },
                         {"Name":'Enabled',
                          "Kind":B_InstallEnable,
                          "VSep":10,
                          "Command":ModEnableDisable
                         },
                         {"Name":MenuText.GetMenuText("OPTIONS"),
	     	          "Kind":B_BLMenuItemTextNoFX,
                          "VSep":10,
                          "ListDescr":[]
                         },                
                         {"Name":'Msg1',
                          "VSep":10,
                          "Kind":B_BLDescriptorLabel
                         },                
                         {"Name":'Msg2',
                          "VSep":5,
                          "Kind":B_BLDescriptorLabel
                         },                
                         {"Name"       : MenuText.GetMenuText("BACK"),
                          "VSep"       : 20,
                          "Command"    : Menu.BackMenu,
                         },
                         {"Name"       : "Back",
                          "Kind"       : MenuWidget.B_BackBlank
                         }
                        ]

	MenuLabel ['Servers'] = MenuText.GetMenuText("Servers")

	DownloadsMenu = [{"Name":'Servers',
                          "VSep":60,
                          "Font":Menu.MenuFontBig,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":"",
                          "Font":Menu.MenuFontBig,
                          "Kind":B_BLMenuItemOption,
                          "VSep":30,
                          "Options":RServers,
                          "SelOptionFunc":GetCurrentServer,
                          "Command":NextServer
                         },
                         {"Name":'RSLocation',
                          "VSep":10,
                          "Font":Menu.MenuFontMed,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'RSWebSite',
                          "VSep":10,
                          "Font":Menu.MenuFontMed,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'RSStatus',
                          "VSep":20,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'RSNMods',
                          "VSep":10,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":'RSNMaps',
                          "VSep":10,
                          "Kind":B_BLDescriptorLabel
                         },
                         {"Name":MenuText.GetMenuText("CONTINUE"),
	     	          "Kind":B_BLMenuItemTextNoFX,
                          "VSep":40,
                          "ListDescr":[]
                         },                
                         {"Name"       : MenuText.GetMenuText("BACK"),
		          "VSep"       : 20,
                          "Command"    : Menu.BackMenu,
                         },
                         {"Name"       : "Back",
                          "Kind"       : MenuWidget.B_BackBlank
                         }
                        ]

   	
   	KeybActions = []
#   	ControlsMenu = [{"Name":"KeybList",
#                            "Kind":KeybWidget.B_KeybListWidget,
#                            "VSep":120,
#                            "Size":(610,200),
#                            "ListDescr":KeybActions
#                           },
#                           Menu.BackOption,
#                           {"Name":"Back",
#                            "Kind":MenuWidget.B_BackImageWidget
#                           }
#                         ]
              
	ExtensionsMenu = {"Name":MenuText.GetMenuText("MODS"),
                          "Font":Menu.MenuFontBig,
                          "VSep":10,
                          "Size":(640,480),
                          "ListDescr":[
                                       {"Name":'BODVersion',
                                        "VSep":100,
                                        "Kind":B_BLDescriptorLabel
                                       },
                                       {"Name"       : MenuText.GetMenuText("INSTALLED MODS"),
                                        "VSep"       : 60,
                                        "ListDescr"  : InstalledModsMenu
                                       },
#                                       {"Name"       : MenuText.GetMenuText("CONTROLS"),
#                                        "VSep"       : 20,
#                                        "ListDescr"  : ControlsMenu
#                                       },
                                       {"Name"       : MenuText.GetMenuText("SETUP"),
                                        "VSep"       : 20,
                                        "ListDescr"  : ModConfigMenu
                                       },
                                       {"Name"       : MenuText.GetMenuText("LOAD CUSTOM MAP"),
                                        "VSep"       : 20,
                                        "ListDescr"  : MapMenu
                                       },
                                       {"Name"       : MenuText.GetMenuText("DOWNLOADS"),
                                        "VSep"       : 20,
                                        "ListDescr"  : DownloadsMenu
                                       },
                                       {"Name"       : MenuText.GetMenuText("BACK"),
                                        "VSep"       : 20,
                                        "Command"    : Menu.BackMenu,
                                       },
                                       {"Name"       : "Back",
                                        "Kind"       : MenuWidget.B_BackBlank
                                       }
                                      ]
                         }
	Menu.Desc1["ListDescr"].insert(len(Menu.Desc1["ListDescr"])-2, ExtensionsMenu)
	Menu.GetMenuItem(["EXIT"])["VSep"]=10

##############################################################################
## Main Code
##############################################################################

if ArenaAllowed or netgame.GetNetState() == 0:
	LoadForeingDict ()
	LoadAvailableMods ()
	LoadAvailableMaps ()
	GetCurrentMod ()
	GetCurrentMap ()
	InitializeServers()
	BuildExtensionsMenu ()
	InitializeModules ()
	ReBuildInstalledModsMenu ()
else:
	Reference.debugprint ("BODLoader: Disabled in Arena Mode ")

##############################################################################
## Generate Map Templates
##############################################################################

def GenPjFile ():

	global BLCurrentMap
	global BLMapInfo
	
	dname = BLMapInfo[BLCurrentMap]['DirName']

        file = open ('../'+dname+'/pj.py', 'wt')
        
	file.write ('## pj.py file generated by BODLoader version '+ BLVersion+'\n')

	file.write (' \n')
	file.write ('import AniSound\n')
	file.write ('import Basic_Funcs\n')
	file.write (' \n')

	file.write ('char=Bladex.CreateEntity("Player1","%s", %s, %s, %s, "Person")\n'%(BLMapInfo[BLCurrentMap]['Character'],BLMapInfo[BLCurrentMap]['Position'][0],BLMapInfo[BLCurrentMap]['Position'][1],BLMapInfo[BLCurrentMap]['Position'][2]))
	file.write ('char.Data=Basic_Funcs.PlayerPerson(char)\n')
	file.write ('char.Data.ResetSounds("Player1")\n')
	file.write (' \n')
	file.write ('char.SendTriggerSectorMsgs=1\n')
	file.close()

def GenCfgFile ():

	global BLCurrentMap
	global BLMapInfo
   	global LeveName
	
	dname = BLMapInfo[BLCurrentMap]['DirName']

	file = open ('../'+dname+'/cfg.py', 'wt')
	file.write ('## cfg.py file generated by BODLoader version '+ BLVersion+'\n')
	file.write (' \n')
	file.write ('import Bladex\n')
	file.write ('import LoadBar\n')
	file.write (' \n')
	file.write ('LoadBar.AutoProgressBar(366,"Blade_progress.jpg")\n')
	file.write (' \n')
	file.write ('execfile("..\\..\\Scripts\sys_init.py")\n')
   	file.write (' \n')
   	file.write ('Bladex.ReadLevel("%s")'%(LevelName))
   	file.write (' \n')
	file.write ('execfile("..\\..\\Scripts\BladeInit.py")\n')

	file.close()

def GenLvlFile (World, WorldDome, mmps):

	global BLCurrentMap
	global BLMapInfo
   	global LevelName
	
	dname = BLMapInfo[BLCurrentMap]['DirName']

        file = open ('../'+dname+'/'+BLCurrentMap+'.lvl', 'wt')
   	file.write ('## '+LevelName+' file generated by BODLoader version '+ BLVersion+'\n')
	file.write (' \n')
	file.write ('Bitmaps -> ..\\..\\3dObjs\\3dobjs.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dObjs\\weapons.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dObjs\\genericos.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dobjs\\objetos_p.mmp\n')

	file.write ('Bitmaps -> ..\\..\\3dchars\\Actors.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Skl.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Amz.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Amzskin1.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Amzskin2.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Bar.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Barskin1.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Barskin2.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Chk.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\cosita.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Crow.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\DalGurak.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\DarkKnight.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\darklord.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Dork.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\dwf.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Dwfskin1.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Dwfskin2.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\enanos.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Gdemon.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Glm_cl.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Glm_ic.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Glm_lv.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Glm_mt.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Glm_st.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Gok.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Kgt.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Kgtskin1.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Kgtskin2.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\lch.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Ldm.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\min.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\NPK.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Org.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\ork.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\rgn.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\roturas.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Slm.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\spd.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\TKN.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\trl_dk.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\trl_SN.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\Vmp.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\wyv.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\zkn.mmp\n')
	file.write ('Bitmaps -> ..\\..\\3dchars\\actors_javi.mmp\n')
	for bm in mmps:
	    file.write ('Bitmaps -> '+bm+'\n')
	file.write (' \n')
	file.write (' \n')
	file.write ('World ->     %s\n'%(World))
	file.write ('WorldDome -> %s\n'%(WorldDome))

	file.close()

Reference.debugprint ("BODLoader: End")
